<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');


class TablebookingViewRestaurants extends JViewLegacy {
	
	protected $items;
	protected $pagination;
	protected $state;

	public function display($tpl = null) {

		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');
		$this->addToolbar();
		
		parent::display($tpl);
	}
	

	public function addToolbar() {	
	
		$canDo	= TableBookingHelper::getActions();
		
		JToolBarHelper::title(   'TableBooking :: ' . JText::_( 'COM_TABLEBOOKING_RESTAURANTS' ), '' );	
		
		if ($canDo->get('core.create')) {
			JToolBarHelper::addNew('restaurant.add', 'JTOOLBAR_NEW');
		}
		
		if ($canDo->get('core.edit')) {
			JToolBarHelper::editList('restaurant.edit','JTOOLBAR_EDIT');
		}

		if ($canDo->get('core.delete')) {
			JToolBarHelper::custom('restaurants.delete', 'delete.png', 'delete.png', 'JTOOLBAR_DELETE' , true);
		}

		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_tablebooking');
			JToolBarHelper::divider();
		}	
	}
	
}
?>
