<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class com_tablebookingInstallerScript
{
    function update($parent)
    {
        $version = $this->getVersion();

        if ($version > 0 && version_compare($version, '5.2', '<')) {
            $this->createCronTable();
        }

        if (($version > 0) && version_compare($version, '5.5', '<'))
        {
            $this->addGdpr();
            $this->removeOldArrangement();
        }
    }

	protected function createCronTable() 
	{
		$db = JFactory::getDbo();

		$query = <<<EOF
CREATE TABLE `#__tbb_crons` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `restaurant` int(10) NOT NULL DEFAULT '0',
  `moment_in_time` tinyint(1) NOT NULL DEFAULT '1' COMMENT '0 for before, 1 for after',
  `reservation_status` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'reservation status',
  `x_days` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'days before/after to run the cron',
  `cron_subject` varchar(255) NOT NULL DEFAULT '',
  `cron_message` text NOT NULL,
  `checked_out` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `restaurant` (`restaurant`),
  KEY `restaurant_2` (`restaurant`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
EOF;

		$db->setQuery( $query );
		$db->query();
	}

	protected function addGdpr()
	{
		$db = JFactory::getDbo();

		$query = 'ALTER TABLE `#__tbb_bookings` ADD `gdpr` tinyint(1) unsigned NOT NULL DEFAULT "0" AFTER `status`'; 
		$db->setQuery( $query );
		$db->execute();
	}

    protected function removeOldArrangement()
    {
		$db = JFactory::getDbo();
        $query = 'UPDATE `#__tbb_tables` SET `params`=""';
		$db->setQuery( $query );
		$db->execute();
    }

    function getVersion()
    {
        $version = 0;
        $location =
            JPATH_CONFIGURATION .
            '/administrator/components/com_tablebooking/tablebooking.xml';

        if (file_exists($location))
        {
            $xml = simplexml_load_file($location);
            $version = $xml->version;
        }

        return $version;
    }
}
