<?php

/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');


class TbParams
{

	private static $instance;

	// default date format as YYYY-mm-dd
	public $dateformat = 'Y-m-d';

	// default hour format to 24 hours
	public $hourformat = '24';

	// default empty schedule
	public $schedule = array();
	
	// allow combine tables
	public $combinetables = 1;

	// start & end hour (8.00 and 23.00)
	public $starthour = 28800;
	public $endhour = 82800;

	// default minimum and maximum places allowed to booking; 0 means unlimited
	public $minplaces = 0;
	public $maxplaces = 0;

	// default timeframe when display
	public $timeframe = 900;
	
	// default status for new booking is confirmed (1) ; other values - uncofirmed(0), canceled(2) 
	public $booking_status = 1;

	// receive email when new booking; yes(1), no(0)
	public $receive_email = 0;

	// email config
	public $receive_email_to = '';
	public $receive_email_subject = '';
	public $receive_email_body = '';

	// send email when new booking; yes(1), no(0)
	public $send_email = 0;

	// email config
	public $send_email_subject = '';
	public $send_email_body = '';
	public $send_email_fromname = '';
	
	
	// allow user to choose table
	public $allow_user_choose_table = 0;
	
	// booking length
	public $booking_length = 0;

	// booking list display
	public $booking_list_display = 0;

	// calendar picker first day;  0 -> Sunday ; 1 -> Monday
	public $startcal = 0;
	
    public $email_format = 0;

    public $form_display_phone = 0;
    public $form_display_comments = 0;
    public $gdpr_enable = 0;
    public $gdpr_text = '';

	public static function getInstance( $values,$restaurant_id )
	{

		if (!isset(self::$instance[$restaurant_id]))
		{
			self::$instance[$restaurant_id] = new self( $values );
		}
		return self::$instance[$restaurant_id];
	}


	protected function __construct( $values )
	{
		if(!empty($values))
		{
			$this->bind( $values );
		}
	}


	protected function bind($values)
	{
		foreach ( $values as $key=>$value )
		{
			$this->{$key} = $value;
		}
	}


























}
?>
