<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JFormHelper::loadFieldClass('list');

class JFormFieldAddnewinterval extends JFormField 
{

	public function getInput() 
	{
		$restaurant = TbUser::getInstance()->work->restaurant;
		$hours = TbDisplay::defaultHours($restaurant,true);
		$intervals = '';

		// if we look at an existing schedule add the values of intervals
		$addnewinterval = $this->form->getValue('addnewinterval');
		if (!empty($addnewinterval)) 
		{ 	
			foreach ($addnewinterval as $interval) 
			{
				$enc = urlencode(implode('+',$interval));
				$intervals .= 	'<div class="row">';
				$intervals .= 	'<div class="col-md-9"><p><i class="ico ico-clock"></i> '.TbDisplay::showTime($interval['start'], $restaurant->getParams()->hourformat).' - '.TbDisplay::showTime($interval['end'], $restaurant->getParams()->hourformat).'</p></div>';	
				$intervals .=  	'<div class="col-md-2"><p><a href="javascript:void(0);" onclick="deleteInterval(this);"><i class="ico ico-close"></i></a>';
				$intervals .=  	'<input type="hidden" name="jform[intervals][]" value="'.$enc.'"></input></p></div>';
				$intervals .=  	'</div>';
			}
		}

		$html = '
		<div class="panel panel-default col-md-12">
			<div class="panel-heading">' . JText::_('COM_TABLEBOOKING_ADD_WORKING_INTERVALS') . '</div>

			 <div class="panel-body">

			 	<div id="intervals" class="clearfix">' . $intervals . '</div> 
			 		
				<div class="form-group">
					<select name="start" id="start" class="form-control">
						<option value="0"> - ' . JText::_('COM_TABLEBOOKING_SELECT_START_HOUR') . ' - </option>' . JHtml::_('select.options', $hours) . '
					</select>
	
					<select name="end" id="end" class="form-control">
						<option value="0"> - ' . JText::_('COM_TABLEBOOKING_SELECT_END_HOUR') . ' - </option>' . JHtml::_('select.options', $hours) . '
					</select>
				</div>

				<div class="form-group">
					<button class="input-lg btn btn-default btn-save" onclick="newInterval();return false;"><i class="ico ico-accept"></i>' . JText::_('COM_TABLEBOOKING_ADD') . '</button>
				</div>
			</div>
		</div>';

		return $html;
	} 
	
}
