<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JFormHelper::loadFieldClass('list');

class JFormFieldRestaurantlist extends JFormFieldList {

	public function getInput() 
	{	
		$html = '';
		$selected = JFactory::getApplication()->getUserState('restaurant.id');
		$restaurants = $this->getRestaurants();

		if (empty($restaurants))
		{
			return $html;
		}
		
		if (count($restaurants) > 1) 
		{
			$html .= '<select name="'.$this->name.'" id="jform_restaurant" class="'.$this->element['class'].'" onchange="tbb.changeRestaurant();">';
			$html .= JHtml::_('select.options', $restaurants, 'value','text',$selected, true);
			$html .= '</select>';
		}
		else 
		{
			$html .= '<input type="text" disabled value="'. $restaurants[0]->text . '" class="'.$this->element['class'].'"/>';
			$html .= '<input type="hidden" name="'.$this->name.'" id="jform_restaurant" value="'.$restaurants[0]->value.'" class="'.$this->element['class'].'" />';
		}
		
		return $html;
	}
	
	protected function getRestaurants() 
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('id AS value, title AS text ');
		$query->from($db->quoteName('#__tbb_restaurants'));
		$query->where($db->quoteName('published') . ' = 1');
		
		$db->setQuery($query);
		return $db->loadObjectList();
	}
}
