<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.modeladmin');

class TableBookingModelSettings extends JModelAdmin
{

	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_tablebooking.settings', 'settings', array('control' => 'jform', 'load_data' => $loadData));
        $restaurant = TbUser::getInstance()->work->restaurant;

        if ($restaurant->getParams()->email_format == 1) 
        {
            $form->setFieldAttribute('send_email_body', 'type', 'editor');
            $form->setFieldAttribute('send_email_body', 'filter', 'raw');
            $form->setFieldAttribute('receive_email_body', 'type', 'editor');
            $form->setFieldAttribute('receive_email_body', 'filter', 'raw');
        }

		if (empty($form)) {
			return false;
		}
		
		return $form;
	}


	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_tablebooking.edit.settings.data', array());
		if(empty($data))
		{
			$data = $this->getSettings();
		}
		
		return $data;
	}


	public function save($data) 
	{
		$user = TbUser::getInstance();
		if ( $user->work->position == 2 )
		{
			$restaurant = $user->work->restaurant->id;
			$params = json_encode( $data );

			$query = $this->_db->getQuery(true);
			$query->update($this->_db->quoteName('#__tbb_restaurants'));
			$query->set($this->_db->quoteName('params') . '=' . $this->_db->quote($params));
			$query->where($this->_db->quoteName('id') . '=' . $restaurant);
		
			$this->_db->setQuery( $query );
			$this->_db->query();
		}
		return true;
	}


	protected function getSettings()
	{
		$settings = array();
		$restaurant = TbUser::getInstance()->work->restaurant->id;
		$query = $this->_db->getQuery(true);
		$query->select('params');
		$query->from($this->_db->quoteName('#__tbb_restaurants'));
		$query->where($this->_db->quoteName('id') . '=' . $restaurant);

		$this->_db->setQuery( $query );
		$rez = $this->_db->loadResult();

		if( $rez )
		{
			$settings = json_decode( $rez );
		}
		return $settings;
	}

}
?>
