<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

?>
<div id="tablebooking">

	<form action="<?php echo JRoute::_('index.php?option=com_tablebooking&view=booking&layout=edit', false);?>" method="post" name="adminForm" id="adminForm" class="form-horizontal">
		
		<?php echo TbDisplay::loadMenu() ;?>

		<div id="tb-controls">
		    <div class="col-md-4 pull-left">
			<h3><?php echo JText::_('COM_TABLEBOOKING_BOOKINGS');?></h3>
		    </div>
		</div>

		<div class="row tbb-action">
			<div class="col-md-12">
				<button class="btn" onclick="document.adminForm.task.value='booking.save';document.adminForm.submit();"><i class="ico ico-accept"></i> <?php echo JText::_('COM_TABLEBOOKING_SAVE');?></button>
				<button class="btn" onclick="tbb.close();return false;"><i class="ico ico-close"></i> <?php echo JText::_('COM_TABLEBOOKING_CLOSE');?></button>
			</div>
		</div>

		<!-- display errors -->
		<div id="error-display" class="alert alert-danger hidden" role="alert"></div>
		<!-- /display errors -->
		
		<?php $fields = array('calendar', 'bookstart', 'bookend', 'places','status', 'restaurant'); foreach ( $fields as $field ) { ?> 
		<div class="form-group">
			<label class="control-label col-md-2"> <?php echo $this->form->getLabel( $field ); ?> </label>
			<div class="controls cold-md-10" style="position: relative;">
				<?php echo $this->form->getInput( $field ); ?>
			</div>
		</div>
		<?php } ?>

		<!-- display tables -->
		<div id="available-tables">
			<?php if ($this->item->id) { ?>
			<div class="form-group">
				<label class="control-label col-md-2"><?php echo JText::_('COM_TABLEBOOKING_SEARCH_AVAILABLE_TABLES');?></label>
				<div class="controls cold-md-10">
					<span class="label label-primary pull-left selected"><i class="ico ico-tables"></i> <?php echo implode(' + ', $this->selected) ; ?></span>
				</div>
			</div>
			<?php } ?>
		</div>
		<!-- /display tables -->

		<?php $fields = array('extracomments', 'name', 'email', 'phone', 'comments'); foreach ( $fields as $field ) { ?> 
		<div class="form-group">
			<label class="control-label col-md-2"> <?php echo $this->form->getLabel( $field ); ?> </label>
			<div class="controls cold-md-10">
				<?php echo $this->form->getInput( $field ); ?>
			</div>
		</div>
		<?php } ?>
		
		
		<?php echo $this->form->getInput( 'table' ); ?>
		<?php echo $this->form->getInput( 'bookdate' ); ?>
		<?php echo $this->form->getInput( 'id' ); ?>
		
		<input type="hidden" name="jform[restaurant]" value="<?php echo $this->restaurant->id;?>" />
		<input type="hidden" name="timestamp" id="timestamp" />
		<input type="hidden" name="task" />
		<?php echo JHtml::_('form.token'); ?>
	</form>
</div>


<script>
	var DateConfig = {
		fullCurrentMonth: true,
		dateFormat: '<?php echo $this->restaurant->getParams()->dateformat;?>',
		<?php if ($this->restaurant->getParams()->startcal == 1) { ?>
		weekdays: ['<?php echo JText::_("COM_TABLEBOOKING_MONDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_TUESDAY", true);?>', 
		  			'<?php echo JText::_("COM_TABLEBOOKING_WEDNESDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_THURSDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FRIDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SATURDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SUNDAY", true);?>'],
		<?php } else { ?>
		weekdays: ['<?php echo JText::_("COM_TABLEBOOKING_SUNDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MONDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_TUESDAY", true);?>', 
		  			'<?php echo JText::_("COM_TABLEBOOKING_WEDNESDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_THURSDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FRIDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SATURDAY", true);?>'],
		<?php } ?>
		months: ['<?php echo JText::_("COM_TABLEBOOKING_JANUARY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FEBRUARY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MARCH", true);?>', 
			  '<?php echo JText::_("COM_TABLEBOOKING_APRIL", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_JUNE", true);?>', 
			  '<?php echo JText::_("COM_TABLEBOOKING_JULY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_AUGUST", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SEPTEMBER", true);?>', 
			  '<?php echo JText::_("COM_TABLEBOOKING_OCTOBER", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_NOVEMBER", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_DECEMBER", true);?>'],
		suffix: { 1: 'st', 2: 'nd', 3: 'rd', 21: 'st', 22: 'nd', 23: 'rd', 31: 'st' },
		defaultSuffix: 'th', 
		<?php if ($this->state->get('filter.bookings.timestamp')) { ?>
		currentTime: <?php echo (int) $this->state->get('filter.bookings.timestamp');?>,
		<?php } else { ?>
		currentTime: <?php echo time() * 1000;?>,
		<?php } ?>
		_startCal: '<?php echo $this->restaurant->getParams()->startcal;?>'
	};

	new datepickr('jform_calendar', 'jform_calendar', DateConfig);

  	var dat = new DateHelper();	
  	var utils = new MedialUtilities();
  	var UserInput = {'date': document.getElementById('jform_bookdate'), 'places':document.getElementById('jform_places'), 'start':document.getElementById('jform_bookstart'), 'end':document.getElementById('jform_bookend'), 'calendar':document.getElementById('jform_calendar')};

  	var tbb = 
  	{
		changedate: function(x) { 
			var timestamp = dat.toTimestamp(x); 
			document.getElementById('jform_bookdate').value = dat.toCustom(timestamp, 'Y-m-d'); 
			document.getElementById('jform_calendar').value = dat.toCustom(timestamp, DateConfig.dateFormat); 
			tbb.changeHours(dat.toCustom(timestamp, 'Y-m-d'));
	  	},

	  	close: function() {
			document.adminForm.task.value='booking.close';document.adminForm.submit();
	  	},
	  	
	  	changeHours: function(x) {
	  		var params = 'date=' + x;
	  		var url = '<?php echo JRoute::_('index.php?option=com_tablebooking&task=booking.getHours&tmpl=component&' . JFactory::getSession()->getFormToken() . '=1', false);?>';
	  		utils.makeAjaxCall(url,'POST',params,function(msg) {
	  			var response = JSON.parse(msg);
	  			var innerHours = '';
				if (response != 0) {
					for(var r in response) {
						innerHours += '<option value="'+r+'">'+response[r]+'</option>';
					}
					document.getElementById('jform_bookstart').innerHTML = innerHours;
					document.getElementById('jform_bookend').innerHTML = innerHours;
				}
	  		});
	  	},
  	}

  	function getTables() {

		if (UserInput.date.value && Number(UserInput.places.value) > 0 && UserInput.start.value && UserInput.end.value) {
			
			var params = 'date=' + UserInput.date.value + '&places=' + UserInput.places.value + '&start=' + UserInput.start.value + '&end=' + UserInput.end.value + '&restaurant=' + <?php echo $this->restaurant->id ;?> + '&booking=' +  <?php echo (int)$this->item->id;?> + '&<?php echo JFactory::getSession()->getFormToken();?>=1';
			var url = '<?php echo JRoute::_('index.php?option=com_tablebooking&task=booking.getTables&tmpl=component', false);?>';
			utils.makeAjaxCall(url,'POST',params,function(msg) {
				var response = JSON.parse(msg);
				if (response.error) {
					document.getElementById('error-display').innerHTML = response.error;
					utils.removeClass(document.getElementById('error-display'),'hidden');
                    setTimeout(function(){
                        utils.addClass(document.getElementById('error-display'),'hidden')
                    }, 5000);
				} 
				else { 
					document.getElementById('jform_table').value = response.selected; 
				}
			});
		}
	};


    //initialize form with selected date
    window.onload = function(){

    	var bookdate 	= document.getElementById('jform_bookdate');
    	var places 		= document.getElementById('jform_places');
    	var bookstart 	= document.getElementById('jform_bookstart');
    	var bookend 	= document.getElementById('jform_bookend');
    	var calendar 	= document.getElementById('jform_calendar');
    	var days 		= document.getElementsByClassName('day');

    	places.addEventListener('change', getTables);
		bookstart.addEventListener('change', getTables);
		bookend.addEventListener('change', getTables);

    	<?php if ( !$this->item->id ) { ?>
    		
	    	<?php if ( !$this->form->getValue('bookdate') ) {?> 
	    		bookdate.value = dat.toCustom(DateConfig.currentTime, 'Y-m-d');
	    	<?php } ?>
	    	
	    	<?php if ( $this->form->getValue('calendar') ) { ?> 
	    		calendar.value = '<?php echo $this->form->getValue('calendar');?>';
	    	<?php } ?>

	    	getTables();
    	<?php } else { ?>
    		var timestamp = '<?php echo TbDisplay::strToTime($this->item->bookdate) * 1000 ;?>';
    		calendar.value = dat.toCustom(timestamp, DateConfig.dateFormat);
    	<?php } ?>


		for (var i=0; i<days.length; i++) {
			days[i].addEventListener('click', function (el){
				tbb.changedate(el.target.getAttribute('data-date'));
			}),
			days[i].addEventListener('mouseover', function (el){
				el.target.className = 'day circled';
			}),
			days[i].addEventListener('mouseout', function (el){
				el.target.className = 'day';
			})
		}
	}
    
</script>
