<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class TableBookingViewCrons extends JViewLegacy
{
	protected $crons;
	protected $restaurant;
	protected $statuses;
	
	public function display($tpl = null)
	{
		$user = TbUser::getInstance();
		
		if (!$user->isAuthorized('management')) 
		{
			JFactory::getApplication()->redirect('index.php?option=com_users');
			return false;
		}
		
		$this->crons = $this->get('Items');
		$this->restaurant = $user->work->restaurant; 
		$this->statuses = array(
			JText::_('COM_TABLEBOOKING_UNCONFIRMED'),
			JText::_('COM_TABLEBOOKING_CONFIRMED'),
			JText::_('COM_TABLEBOOKING_CANCELED'),
			JText::_('COM_TABLEBOOKING_SEATED'),
		);

		$this->addResources();
		parent::display($tpl);
	}

	public function addResources() {	
	
		JHtml::stylesheet( 'components/com_tablebooking/assets/css/bootstrap.css' );
		JHtml::stylesheet( 'components/com_tablebooking/assets/css/style.css' );
		JHtml::stylesheet( 'components/com_tablebooking/assets/medial/style.css' );
		JHtml::script( 'components/com_tablebooking/assets/js/tbb.js' );
		JHtml::script( 'components/com_tablebooking/assets/js/calendar.js' );
	}
}
?>
