<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class TableBookingViewDashboard extends JViewLegacy
{
	  protected $restaurant;
	  protected $hours;
	  protected $bookings;

	  public function display($tpl = null)
	  {
			if (!TbUser::getInstance()->isAuthorized('management')) 
			{
				JFactory::getApplication()->redirect('index.php?option=com_users');
				return false;
			}
			
	  		$this->restaurant = TbUser::getInstance()->work->restaurant; 

		    $date = JRequest::getVar('date'); 
		    $timestamp = TbDisplay::strToTime( $date );
		    $dateobj = TbSchedule::getDate($timestamp);


		    // first let's see if a schedule is set for the date
			$schedule = $this->restaurant->getSchedule($dateobj); 
			
			// if a schedule for that certain date doesn't exist default to the schedule for the week day
			if (!$schedule->isSet)
			{
				$schedule = $this->restaurant->getSchedule($dateobj->__get('dayofweek'));
			}

			$this->hours = $schedule->working ? $schedule->getHours(true) : array('0'=>JText::_('COM_TABLEBOOKING_NON_WORKING'));
		    $this->bookings = TbBookingsList::getInstance($date);
		    
		    parent::display($tpl);
		    exit();
	  }
}
?>
