<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

?>
<div id="tablebooking">

    <form 
        action="<?php echo JRoute::_('index.php?option=com_tablebooking&view=management', false);?>"
        method="post" name="adminForm" id="adminForm" class="form-horizontal">

		<?php echo TbDisplay::loadMenu();?>

		<div id="tb-controls">
		    <div class="col-md-4 pull-left">
			<h3><?php echo JText::_('COM_TABLEBOOKING_DASHBOARD');?></h3>
		    </div>

		    <div class="col-md-7 tb-span-control">
			  <i id="calendar" class="ico ico-calendar pull-left"></i>
              <i class="ico ico-go-left-circle pull-left command"
                onclick="tbb.minus1Day();"></i>
              <span class="col-md-6 pull-left">
                <input id="calendar-value" type="text" /></span>
              <i class="ico ico-go-right-circle pull-left command"
                onclick="tbb.plus1Day();"></i>
		    </div>
		</div>

		<div id="tb-view"></div>

		<div class="col-md-12">
            <div class="col-md-2 pull-left">
                <i class="ico ico-tables status--1"></i>
                <?php echo JText::_('COM_TABLEBOOKING_FREE');?></div>
            <div class="col-md-3 pull-left">
                <i class="ico ico-tables status-0"></i>
                <?php echo JText::_('COM_TABLEBOOKING_UNCONFIRMED');?></div>
            <div class="col-md-3 pull-left">
                <i class="ico ico-tables status-1"></i>
                <?php echo JText::_('COM_TABLEBOOKING_CONFIRMED');?></div>
            <div class="col-md-2 pull-left">
                <i class="ico ico-tables status-2"></i>
                <?php echo JText::_('COM_TABLEBOOKING_CANCELED');?></div>
            <div class="col-md-2 pull-left">
                <i class="ico ico-tables status-3"></i>
                <?php echo JText::_('COM_TABLEBOOKING_SEATED');?></div>
		</div>

		<div id="tb-view-arrangements">
			<h3><?php echo JText::_('COM_TABLEBOOKING_TABLES_ARRANGEMENTS');?></h3>
			<div id="arrangements">
                <div id="unassigned">
                <?php if (!empty($this->arrangements->unassigned)) {?>
                <?php foreach ($this->arrangements->unassigned as $table) {?>
                    <div class="draggable shape-<?php echo $table->shape;?>"
                        draggable="true"
                        data-table="<?php echo $table->id;?>"
                        ondragstart="event.dataTransfer.setData('text/plain',null)">
                        <?php echo $table->name;?>
                    </div> 
                <?php } ?>
                <?php } ?>
                </div>
                <div id="assigned">
                <?php for ($i = 0; $i<=$this->arrangements->axes->fixed[0]; $i++) {?>
                <div class="line">
                <?php for ($j = 0; $j<=$this->arrangements->axes->fixed[1]; $j++) {?>
                <div class="dropzone"
                    data-position="<?php echo $i . 'x' . $j;?>">
                <?php if(!is_null($item = $this->arrangements->assigned[$i][$j])) {?>
                <div class="draggable shape-<?php echo $item->shape;?>"
                    draggable="true"
                    data-table="<?php echo $item->id;?>"
                    title="<?php echo JText::_('COM_TABLEBOOKING_MIN_MAX_PLACES').
                            ': ' . $item->min_places . '/' . $item->max_places;?>"
                    ondragstart="event.dataTransfer.setData('text/plain',null)">
                    <?php echo $item->name;?>
                </div>
                <?php } ?>
                </div>
                <?php } ?>
                </div>
                <?php } ?>
                </div>
			</div>
		</div>
	
	
		<input type="hidden" name="timestamp" id="timestamp" value="" />
		<input type="hidden" name="task" value="" />
		<?php echo JHtml::_('form.token'); ?>
	</form>
</div>


<script type="text/javascript">	  
	var DateConfig = {
		fullCurrentMonth: true,
		dateFormat: '<?php echo $this->restaurant->getParams()->dateformat;?>',
		weekdays: ['<?php echo JText::_("COM_TABLEBOOKING_SUNDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MONDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_TUESDAY", true);?>', 
		  			'<?php echo JText::_("COM_TABLEBOOKING_WEDNESDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_THURSDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FRIDAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SATURDAY", true);?>'],
		months: ['<?php echo JText::_("COM_TABLEBOOKING_JANUARY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_FEBRUARY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MARCH", true);?>', 
			  '<?php echo JText::_("COM_TABLEBOOKING_APRIL", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_MAY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_JUNE", true);?>', 
			  '<?php echo JText::_("COM_TABLEBOOKING_JULY", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_AUGUST", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_SEPTEMBER", true);?>', 
			  '<?php echo JText::_("COM_TABLEBOOKING_OCTOBER", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_NOVEMBER", true);?>', '<?php echo JText::_("COM_TABLEBOOKING_DECEMBER", true);?>'],
		suffix: { 1: 'st', 2: 'nd', 3: 'rd', 21: 'st', 22: 'nd', 23: 'rd', 31: 'st' },
		defaultSuffix: 'th'
	};
	
	new datepickr('calendar', 'calendar-value', DateConfig);
	  
	var dat = new DateHelper();	
	var utils = new MedialUtilities();

	var date = {
		timestamp : function() { return document.getElementById('timestamp').value; },
		selectedDate : function() { return dat.toCustom(document.getElementById('timestamp').value,DateConfig.dateFormat); },
		phpDate : function() { return dat.toCustom(document.getElementById('timestamp').value,'Y-m-d'); },
		hour : 0,
	};
	
	var tbb = {

 		// get the data based on selected date
 		// reset possible selected hour 
    	updateData: function(seldate) { 
			date.hour = 0;
			var url = '<?php echo JUri::root();?>index.php?option=com_tablebooking&view=dashboard&date=' + seldate;
			var params = null;
			utils.makeAjaxCall(url,'POST',params,function(data) {
				document.getElementById('tb-view').innerHTML = data;
			});
		},

		changedate: function(x) { 
			var timestamp = dat.toTimestamp(x);
			document.getElementById('timestamp').value = timestamp;
			document.getElementById('calendar-value').value = dat.toCustom(timestamp,DateConfig.dateFormat);
			this.updateData(dat.toCustom(timestamp,'Y-m-d'));
		},

		plus1Day: function() {
			var timestamp = document.getElementById('timestamp').value;
			var nexttimestamp = dat.plus1Day(parseInt(timestamp));
			document.getElementById('timestamp').value = nexttimestamp;
			document.getElementById('calendar-value').value = dat.toCustom(nexttimestamp,DateConfig.dateFormat);
			this.updateData(dat.toCustom(nexttimestamp,'Y-m-d'));
		},

		minus1Day: function() {
			var timestamp = document.getElementById('timestamp').value;
			var nexttimestamp = dat.minus1Day(parseInt(timestamp));
			document.getElementById('timestamp').value = nexttimestamp;
			document.getElementById('calendar-value').value = dat.toCustom(nexttimestamp,DateConfig.dateFormat);
			this.updateData(dat.toCustom(nexttimestamp,'Y-m-d'));
		},
	};

	//initialize form with current date
    window.onload = function() {
    	var timestamp = document.getElementById('timestamp').value;
    	tbb.updateData(dat.toCustom(timestamp, 'Y-m-d'));

    	var days = document.getElementsByClassName('day');
    	for (var i=0; i<days.length; i++) {
			days[i].addEventListener('click', function (el){
				tbb.changedate(el.target.getAttribute('data-date'));
			})
		}
    }

    /*
    * https://developer.mozilla.org/en-US/docs/Web/Events/drag
    */
    var dragged;
    document.addEventListener("dragstart", function(event) {
        dragged = event.target;
        event.target.style.opacity = .8;
    }, false);

    document.addEventListener("dragend", function(event) {
        event.target.style.opacity = "";
    }, false);

    document.addEventListener("dragover", function(event) {
        event.preventDefault();
    }, false);

    document.addEventListener("drop", function(event) {
        event.preventDefault();
        if (event.target.className == "dropzone") {
            dragged.parentNode.removeChild(dragged);
            event.target.appendChild(dragged);
            setTablePosition(dragged.dataset.table,event.target.dataset.position);
        }
    }, false);

    function setTablePosition(table, position) {
        if (table && position){
            var url = '<?php echo JUri::root();?>'+
                    'index.php?option=com_tablebooking&task=table.setPosition';
            var params = 'restaurant='+'<?php echo $this->restaurant->id;?>'+
                        '&table='+table+'&position='+position;
            utils.makeAjaxCall(url,'POST',params,function(data) {});
        }
    }
</script>
