<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

?>

<div id="tablebooking">

	<form action="<?php echo JRoute::_('index.php?option=com_tablebooking&view=settings', false);?>" method="post" name="adminForm" id="adminForm" class="form-horizontal">
		
		<?php echo TbDisplay::loadMenu() ;?>

		<div id="tb-controls">
		  <div class="col-md-4 pull-left">
		   	<h3><?php echo JText::_('COM_TABLEBOOKING_SCHEDULES');?></h3>
		  </div>
		</div>

		<?php $parts = array( 1=>'MONDAY', 2=>'TUESDAY', 3=>'WEDNESDAY', 4=>'THURSDAY', 5=>'FRIDAY', 6=>'SATURDAY', 7=>'SUNDAY', 8=>'COM_TABLEBOOKING_SPECIAL_DAYS') ;?>
		<?php for ($i=1; $i<=7; $i++) {?>

		<!-- day -->
		<div class="day" data-id="<?php echo $i;?>" id="part-<?php echo $i;?>">

			<!-- add new interval form -->
			<div class="panel panel-default addSchedule">
				<div class="panel-heading">
					<?php echo JText::_('COM_TABLEBOOKING_ADD_WORKING_INTERVALS');?>
				</div>

				 <div class="panel-body">
					
					<div class="form-group">
						<select class="input-sm start">
							<option value="0"> - <?php echo JText::_('COM_TABLEBOOKING_SELECT_START_HOUR') ;?> - </option>
							<?php echo JHtml::_('select.options', $this->hours) ;?>
						</select>
		
						<select class="input-sm end">
							<option value="0"> - <?php echo JText::_('COM_TABLEBOOKING_SELECT_END_HOUR') ;?> - </option>
							<?php echo JHtml::_('select.options', $this->hours) ;?>
						</select>
					</div>

					<div class="form-group">
						<button class="input-lg btn btn-default btn-save" data-id="<?php echo $i;?>"><i class="ico ico-accept"></i> <?php echo JText::_('COM_TABLEBOOKING_SAVE');?></button>
						<button class="input-lg btn btn-default btn-cancel"><i class="ico ico-close"></i> <?php echo JText::_('COM_TABLEBOOKING_CLOSE');?></button>
					</div>
			
				</div>
			</div>
			<!-- /add new interval form -->

			<!-- schedules -->
			<div class="well well-lg">

				<?php for ($j=1; $j<=7; $j++) {?>
				<a class="btn-sm" href="#part-<?php echo $j;?>">
					<?php if ($i==$j) {?><span class="label label-primary"><?php } ?>
					<?php echo JText::_($parts[$j]);?>
					<?php if ($i==$j) {?></span><?php } ?>
				</a>		
				<?php } ?>
				<a class="btn-sm" href="#special"><?php echo JText::_($parts[8]);?></a>	

				<h2><?php echo JText::_($parts[$i]);?></h2>
				<p class="status-info">	
					<span class="label status<?php echo $this->schedules[$i]->working;?>">
						<?php echo $this->schedules[$i]->working ? JText::_('COM_TABLEBOOKING_WORKING') : JText::_('COM_TABLEBOOKING_NON_WORKING');?>
					</span>
				</p>

				<p><?php echo JText::sprintf(JText::_('COM_TABLEBOOKING_CURRENT_HOURS'),$parts[$i]);?></p>

				<div class="schedules">
					<table class="table">
						<thead>
							<tr>
								<th><?php echo JText::_('COM_TABLEBOOKING_BOOKINGS_START');?></th>
								<th><?php echo JText::_('COM_TABLEBOOKING_BOOKINGS_END');?></th>
								<th></th>
							</tr>
						</thead>
						<tbody>
							<?php $intervals = $this->schedules[$i]->getIntervals(); if(!empty($intervals)) { foreach ($intervals as $key => $interval) { ?>
							<tr>
								<td><?php echo TbDisplay::showTime($interval['start']);?></td>
								<td><?php echo TbDisplay::showTime($interval['end']);?></td>
								<td><a href="javascript:void(0);" onclick="tb.deleteInterval(this, '<?php echo $i;?>','<?php echo $interval['start'];?>','<?php echo $interval['end'];?>');return false;"><i class="delete ico ico-close"></i></a></td>
							</tr>								
							<?php } } else { ?> 
								<tr class="no-schedule">
									<td colspan="5">
										<?php echo !$this->schedules[$i]->working ? JText::_('COM_TABLEBOOKING_NON_WORKING') : JText::sprintf(JText::_('COM_TABLEBOOKING_NO_SCHEDULE_FOR_DAY'),$parts[$i], TbDisplay::showTime($this->restaurant->getParams()->starthour), TbDisplay::showTime($this->restaurant->getParams()->endhour));?>
									</td>
								</tr>
							<?php } ?>
						</tbody>
						<tfoot>
							<tr>
								<td colspan="5">
									<button class="btn btn-primary btn-add"><?php echo JText::_('COM_TABLEBOOKING_ADD_WORKING_INTERVALS');?></button>
									<button class="btn btn-toogle-work">
										<?php echo $this->schedules[$i]->working ? JText::_('COM_TABLEBOOKING_MARK_NONWORKING') : JText::_('COM_TABLEBOOKING_MARK_WORKING');?>
									</button>
								</td>
							</tr>
						</tfoot>
					</table>
				</div>
			</div>
			<!-- schedules -->

		</div>
		<!-- /day -->
		<?php } ?>
		

		<!-- special days -->
		<div class="well well-lg" id="special">
			<table class="table">
				<thead>
					<tr><th colspan="3"><h2><?php echo JText::_('COM_TABLEBOOKING_SPECIAL_DAYS');?></h2></th></tr>
					<tr><th colspan="3"><button class="btn btn-primary" onclick="tb.newSpecialDay();return false;"><?php echo JText::_('COM_TABLEBOOKING_ADD_SPECIAL_DAY');?></button></th></tr>
				</thead>
				<tbody>
					<?php if(!empty($this->specials)) { foreach ($this->specials as $key=>$day) { ?>
					<tr class="status<?php echo $day->working;?>">
						<td>
							<a href="<?php echo JRoute::_('index.php?option=com_tablebooking&view=special&id=' . base64_encode($key), false);?>"><?php echo TbDisplay::showDate($key, $this->restaurant->getParams()->dateformat) ;?></a>
						</td>
						<td>
							<?php echo $day->working ? JText::_('COM_TABLEBOOKING_WORKING') : JText::_('COM_TABLEBOOKING_NON_WORKING'); ?>
						</td>
						<td>
							<a href="javascript:void(0);" onclick="tb.deleteSpecialDay('<?php echo $key;?>',this);"><i class="ico ico-close"></i></a>
						</td>
					</tr>
					<?php } } ?>
				</tbody>
			</table>
		</div>
		<!-- special days -->

		<input type="hidden" name="task" value="" />
		<?php echo JHtml::_('form.token'); ?>
	</form>
</div>


<script>
	//'use strict';

	var utils = new MedialUtilities();

	var tb = {

		updateIntervals: function(d,el){
			
			var url = '<?php echo JRoute::_('index.php?option=com_tablebooking&task=schedules.newRow', false); ?>';
			var params = 'info[id]=' + d.id + '&info[start]=' + d.start + '&info[end]=' + d.end; 
			utils.makeAjaxCall(url,'POST',params,function(msg) {
				var schedules = el.getElementsByClassName('schedules')[0];
				var tbody = schedules.getElementsByTagName('tbody')[0];
				var noschedule = tbody.getElementsByClassName('no-schedule');
				var before = noschedule.innerHTML == undefined ? tbody.innerHTML : '';
				tbody.innerHTML = before + msg;
			});
		},

		changeDayStatus: function(d) {
			var url = '<?php echo JRoute::_('index.php?option=com_tablebooking&task=schedules.changeDayStatus', false); ?>';
			var params = 'info[id]=' + d['id'] + '&info[status]=' + d['status'];
			utils.makeAjaxCall(url,'POST',params,function(msg) {
			});
		},

		deleteInterval: function(el,id,start,end) {
			var url = '<?php echo JRoute::_('index.php?option=com_tablebooking&task=schedules.deleteInterval', false); ?>';
			var params = 'info[id]=' + id + '&info[start]=' + start + '&info[end]=' + end;
			utils.makeAjaxCall(url,'POST',params,function(msg) {
				utils.getParent(el,'tr').remove();
			});
		},

		newSpecialDay: function() {
			document.adminForm.task.value = 'special.addNew';
			document.adminForm.submit();
		},

		deleteSpecialDay: function(day,el) {
			var url = '<?php echo JRoute::_('index.php?option=com_tablebooking&task=schedules.delSpecialDay', false); ?>';
			var params = 'info[day]=' + day;
			utils.makeAjaxCall(url,'POST',params,function(msg) {
				utils.getParent(el,'tr').remove();
			});
		},
	};

	var buttonsAdd = document.querySelectorAll('.btn-add');
	var buttonsToggle = document.querySelectorAll('.btn-toogle-work');
	var buttonsCancel = document.querySelectorAll('.btn-cancel');
	var buttonsSave = document.querySelectorAll('.btn-save');

	for (var i=0;i<buttonsAdd.length;i++){

		buttonsAdd[i].addEventListener('click', function(el) {
			if (el.preventDefault) {
				el.preventDefault();
			} else {
				el.returnValue = false;
			}
			var parent = utils.getParent(el.target,'div.day');
			var schedule = parent.querySelector('div.addSchedule');
			schedule.style.display = 'block';
			schedule.style.zIndex = '99999';
			schedule.style.width = 'auto';
		});

		buttonsToggle[i].addEventListener('click', function(el) {
			if (el.preventDefault) {
				el.preventDefault();
			} else {
				el.returnValue = false;
			}
			var day = utils.getParent(el.target, 'div.day');
			var label = day.querySelectorAll('span.label')[1];
			var newinput = {'id':day.attributes['data-id'].value};

			if (utils.hasClass(label,'status0')) {
				newinput.status = 1;
				label = utils.removeClass(label,'status0');
				label = utils.addClass(label,'status1');
				label.innerHTML = '<?php echo JText::_('COM_TABLEBOOKING_WORKING', true);?>';
				el.target.innerHTML = '<?php echo JText::_('COM_TABLEBOOKING_MARK_NONWORKING', true);?>';
			} else {
				newinput.status = 0;
				label = utils.removeClass(label,'status1');
				label = utils.addClass(label,'status0');
				label.innerHTML = '<?php echo JText::_('COM_TABLEBOOKING_NON_WORKING', true);?>';
				el.target.innerHTML = '<?php echo JText::_('COM_TABLEBOOKING_MARK_WORKING', true);?>';
			}
			tb.changeDayStatus(newinput);
		});
	}

	for (var i=0;i<buttonsCancel.length;i++){

		buttonsCancel[i].addEventListener('click', function(el) {
			if (el.preventDefault) {
				el.preventDefault();
			} else {
				el.returnValue = false;
			}
			var parent = utils.getParent(el.target,'div.day');
			var schedule = parent.querySelector('div.addSchedule');
			schedule.style.display = 'none';
			schedule.style.zIndex = '0';
		});

		buttonsSave[i].addEventListener('click', function(el) {
			if (el.preventDefault) {
				el.preventDefault();
			} else {
				el.returnValue = false;
			}
			var newinput = {};
			var parent = utils.getParent(el.target,'div.day');
			var schedule = parent.querySelector('div.addSchedule');
			newinput.start = parent.querySelector('.panel-body .start').value;
			newinput.end = parent.querySelector('.panel-body .end').value;
			newinput.id = el.target.attributes['data-id'].value;
			
			if (Number(newinput.start) > 0 && Number(newinput.end) >0) {
				tb.updateIntervals(newinput,parent);
			}
			schedule.style.display = 'none';
			schedule.style.zIndex = '0';
		});
	}
</script>
