<?php
/*
 * @component Tablebooking
 * @website : ionutlupu.me
 * @copyright  Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class TableBookingViewSchedules extends JViewLegacy
{
	protected $hours;
	protected $schedules;
	protected $restaurant;
	protected $specials;

	public function display($tpl = null) {

		if (!TbUser::getInstance()->isAuthorized('params')) 
		{
			JFactory::getApplication()->redirect('index.php?option=com_tablebooking');
			return false;
		}
		
		$this->restaurant = TbUser::getInstance()->work->restaurant;
		$this->hours = TbDisplay::defaultHours($this->restaurant,true);
		$this->schedules = array( 
									1 => $this->restaurant->getSchedule(1),
									2 => $this->restaurant->getSchedule(2),
									3 => $this->restaurant->getSchedule(3),
									4 => $this->restaurant->getSchedule(4),
									5 => $this->restaurant->getSchedule(5),
									6 => $this->restaurant->getSchedule(6),
									7 => $this->restaurant->getSchedule(7),
								);
		$this->specials = $this->get('SpecialDays');

		$this->addResources();

		parent::display($tpl);
	}
	
	
	public function addResources() {	
		
		$scheme = JUri::getInstance()->getScheme();

		JHtml::stylesheet( 'components/com_tablebooking/assets/css/bootstrap.css' );
		JHtml::stylesheet( 'components/com_tablebooking/assets/css/style.css' );
		JHtml::stylesheet( 'components/com_tablebooking/assets/medial/style.css' );
		JHtml::script( 'components/com_tablebooking/assets/js/tbb.js' );
		JHtml::script( 'components/com_tablebooking/assets/js/calendar.js' );
	}
}
?>
